/*
 * Copyright (C) 2021 Iopsys Software Solutions AB
 *
 * Author: Suvendhu Hansa <suvendhu.hansa@iopsys.eu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2.1
 * as published by the Free Software Foundation
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */

#ifndef SWMOD_COMMON_H
#define SWMOD_COMMON_H

#include <uci.h>

#define PARENT_EEID	1
#define PROC_PATH "/proc"
#define DW_TMP_DIR_PATH "/tmp"
#define DW_PKG_LOCAL_PATH DW_TMP_DIR_PATH"/dw_package.ipk"

enum swmod_du_opration_enum {
	SWMOD_INSTALL,
	SWMOD_UPDATE,
	SWMOD_REMOVE,
	__SWMOD_OP_MAX
};

typedef struct {
	time_t start;
	char url[2049];
	char uname[257];
	char psw[257];
	char uuid[37];
	char env_name[32];
	int operation;
	struct uci_section *section;
} PkgInfo;

bool memory_available(unsigned long req_kb, const char *dst);
unsigned long get_remote_file_size(const char *url, const char *uname, const char *pwd);
int download_remote_package(const char *url, const char *username, const char *password, const char *dst);

#endif //SWMOD_COMMON_H
